#!/usr/bin/python

import pyglet

from prime.system.window import get_window
from prime.widgets.buttons import BlockButton

window = get_window()

button1 = BlockButton(20, 20, 100, 100, (255, 0, 0))
window.add(button1)

button2 = BlockButton(40, 40, 100, 100, (255, 255, 0))
window.add(button2)

@button1.event
def on_click():
    print "> button1 clicked"
@button2.event
def on_click():
    print "> button2 clicked"

@button1.event
def on_hover():
    button1.color = (0, 0, 255)
    print "> button1 hover"
@button2.event
def on_hover():
    button2.color = (0, 255, 0)
    print "> button2 hover"

@button1.event
def on_nohover():
    button1.color = (255, 0, 0)
    print "> button1 no hover"
@button2.event
def on_nohover():
    button2.color = (255, 255, 0)
    print "> button2 no hover"

@button1.event
def on_mouse_press():
    button1.color = (128, 0, 0)
    print "> button1 press"
@button2.event
def on_mouse_press():
    button2.color = (128, 128, 0)
    print "> button2 press"

@button1.event
def on_mouse_release():
    print "> button1 release"
@button2.event
def on_mouse_release():
    print "> button2 release"

@button1.event
def on_mouse_enter():
    print "> button1 enter"
@button2.event
def on_mouse_enter():
    print "> button2 enter"

@button1.event
def on_mouse_leave():
    print "> button1 leave"
@button2.event
def on_mouse_leave():
    print "> button2 leave"

pyglet.app.run()
