#!/usr/bin/python

import pyglet

from prime.system.window import get_window
from prime.widgets.buttons import BlockButton
from prime.widgets.panels import VPanel
from prime.widgets.panels import HPanel
from prime.widgets.panels import Panel

def add_hover_effect(widget):

    def colorize(widget, color=(255, 255, 255)):
        widget.color = color

    orig_color = widget.color
    widget.on_hover = lambda: colorize(widget)
    widget.on_nohover = lambda: colorize(widget, orig_color)
    widget.on_mouse_press = lambda: colorize(widget, (60, 60, 60))

window = get_window()


panel = VPanel(20, 20, 10)


hpanel1 = HPanel(50, 50, 10)

button1 = BlockButton(0, 0, 60, 60, (255, 0, 0))
add_hover_effect(button1)
hpanel1.add(button1)

button2 = BlockButton(0, 0, 60, 60, (255, 0, 0))
add_hover_effect(button2)
hpanel1.add(button2)

panel.add(hpanel1)
print panel.width, panel.height


hpanel2 = HPanel(0, 0, 10)

button3 = BlockButton(0, 0, 60, 60, (255, 255, 0))
add_hover_effect(button3)
hpanel2.add(button3)

button4 = BlockButton(0, 0, 60, 60, (255, 255, 0))
add_hover_effect(button4)
hpanel2.add(button4)

button5 = BlockButton(0, 0, 60, 60, (255, 255, 0))
add_hover_effect(button5)
hpanel2.add(button5)

panel.add(hpanel2)
print panel.width, panel.height
print panel.x, panel.y
print
print panel.widgets[0].x, panel.widgets[0].y

print panel.widgets[1].x, panel.widgets[1].y
window.add(panel)


pyglet.app.run()
