#!/usr/bin/python

import pyglet

from prime.system.window import get_window
from prime.widgets.buttons import BlockButton
from prime.widgets.panels import VPanel
#from prime.widgets.panels import Panel

def add_hover_effect(widget):

    def colorize(widget, color=(255, 255, 255)):
        widget.color = color

    orig_color = widget.color
    widget.on_hover = lambda: colorize(widget)
    widget.on_nohover = lambda: colorize(widget, orig_color)
    widget.on_mouse_press = lambda: colorize(widget, (60, 60, 60))

window = get_window()


panel1 = VPanel(200, 20, 20)

button2 = BlockButton(40, 40, 60, 60, (255, 255, 0))
add_hover_effect(button2)
panel1.add(button2)

button3 = BlockButton(40, 40, 60, 60, (0, 255, 0))
add_hover_effect(button3)
panel1.add(button3)

button4 = BlockButton(40, 40, 60, 60, (0, 255, 255))
add_hover_effect(button4)
panel1.add(button4)

button9 = BlockButton(40, 40, 60, 60, (0, 255, 255))
add_hover_effect(button9)
panel1.add(button9)

window.add(panel1)


panel2 = VPanel(230, 50, 20)

button6 = BlockButton(350, 20, 60, 60, (128, 64, 0))
add_hover_effect(button6)
panel2.add(button6)

button7 = BlockButton(350, 130, 60, 60, (0, 128, 64))
add_hover_effect(button7)
panel2.add(button7)

button8 = BlockButton(350, 240, 60, 60, (64, 128, 0))
add_hover_effect(button8)
panel2.add(button8)

window.add(panel2)



pyglet.app.run()
