#!/usr/bin/python

import pyglet

from prime.system.window import get_window
from prime.widgets.buttons import BlockButton
from prime.widgets.panels import VPanel
from prime.widgets.panels import HPanel
from prime.widgets.panels import Panel

def add_hover_effect(widget):

    def colorize(widget, color=(255, 255, 255)):
        widget.color = color

    orig_color = widget.color
    widget.on_hover = lambda: colorize(widget)
    widget.on_nohover = lambda: colorize(widget, orig_color)
    widget.on_mouse_press = lambda: colorize(widget, (60, 60, 60))

def add_click_event(widget, name="button"):
    def p(name):
        print "> clicked", name
    widget.on_click = lambda: p(name)

window = get_window()

buttontest = BlockButton(20, window.height - 20 - 60, 60, 60, (255, 0, 0))
add_hover_effect(buttontest)
add_click_event(buttontest)
window.add(buttontest)

vpanel1 = VPanel(20, 20, 30)
window.add(vpanel1)

hpanel1 = HPanel(20, 20, 30)
hpanel2 = HPanel(20, 20, 30)

vpanel1.add(hpanel1)
vpanel1.add(hpanel2)

button1 = BlockButton(0, 0, 60, 60, (255, 0, 0))
add_hover_effect(button1)
add_click_event(button1, "button1")
hpanel1.add(button1)

button2 = BlockButton(0, 0, 60, 60, (255, 0, 0))
add_hover_effect(button2)
add_click_event(button2, "button2")
hpanel1.add(button2)

button3 = BlockButton(0, 0, 60, 60, (255, 0, 0))
add_hover_effect(button3)
add_click_event(button3, "button3")
hpanel2.add(button3)

button4 = BlockButton(0, 0, 60, 60, (255, 0, 0))
add_hover_effect(button4)
add_click_event(button4, "button4")
hpanel2.add(button4)

vpanel2 = VPanel(50, 50, 30)
window.add(vpanel2)

hpanel3 = HPanel(20, 20, 30)
hpanel4 = HPanel(20, 20, 30)

vpanel2.add(hpanel3)
vpanel2.add(hpanel4)

button5 = BlockButton(0, 0, 60, 60, (255, 128, 0))
add_hover_effect(button5)
add_click_event(button5, "button5")
hpanel3.add(button5)

button6 = BlockButton(0, 0, 60, 60, (255, 128, 0))
add_hover_effect(button6)
add_click_event(button6, "button6")
hpanel3.add(button6)

button7 = BlockButton(0, 0, 60, 60, (255, 128, 0))
add_hover_effect(button7)
add_click_event(button7, "button7")
hpanel4.add(button7)

button8 = BlockButton(0, 0, 60, 60, (255, 128, 0))
add_hover_effect(button8)
add_click_event(button8, "button8")
hpanel4.add(button8)

pyglet.app.run()
