#!/usr/bin/python

import pyglet

from prime.system.window import get_window
from prime.widgets.buttons import BlockButton
from prime.widgets.panels import VPanel
from prime.widgets.panels import Panel

def add_hover_effect(widget):

    def colorize(widget, color=(255, 255, 255)):
        widget.color = color

    orig_color = widget.color
    #widget.on_hover = colorize(widget)
    #widget.on_nohover = colorize(widget, orig_color)
    widget.on_hover = lambda: colorize(widget)
    widget.on_nohover = lambda: colorize(widget, orig_color)
    widget.on_mouse_press = lambda: colorize(widget, (60, 60, 60))

window = get_window()

button1 = BlockButton(20, 20, 100, 100, (255, 0, 0))
add_hover_effect(button1)
window.add(button1)

button5 = BlockButton(20, 130, 100, 100, (255, 0, 255))
add_hover_effect(button5)
window.add(button5)

panel1 = VPanel(200, 20, 10)

button2 = BlockButton(40, 40, 100, 100, (255, 255, 0))
add_hover_effect(button2)
panel1.add(button2)

@button2.event
def on_click():
    print ">>> button 2 click"

button3 = BlockButton(40, 40, 100, 100, (0, 255, 0))
add_hover_effect(button3)
panel1.add(button3)

@button3.event
def on_click():
    print ">>> button 3 click"

button4 = BlockButton(40, 40, 100, 100, (0, 255, 255))
add_hover_effect(button4)
panel1.add(button4)

button9 = BlockButton(40, 40, 100, 100, (0, 255, 255))
add_hover_effect(button9)
panel1.add(button9)

window.add(panel1)

panel2 = VPanel(350, 20, 10)

button6 = BlockButton(350, 20, 100, 100, (255, 255, 0))
add_hover_effect(button6)
panel2.add(button6)

button7 = BlockButton(350, 130, 100, 100, (0, 255, 0))
add_hover_effect(button7)
panel2.add(button7)

button8 = BlockButton(350, 240, 100, 100, (0, 255, 255))
add_hover_effect(button8)
panel2.add(button8)

window.add(panel2)



pyglet.app.run()
