class DelegateDesc(object):
    """Descriptor to attribute"""

    def __init__(self, attr, name, on_set=None):
        """attr -- attribute to whom delegate,
        name -- name of delegate attribute,
        on_set -- instance method to call on attribute set."""

        self.attr = attr
        self.name = name
        self.on_set = on_set

    def __get__(self, instance, owner):
        return getattr(getattr(instance, self.attr), self.name)

    def __set__(self, instance, value):
        setattr(getattr(instance, self.attr), self.name, value)
        if self.on_set:
            self.on_set(instance)
