#!/usr/bin/python

import pyglet
import prime

from prime.system.window import get_window
from prime.widgets.panels import HPanel
from prime.widgets.panels import VPanel
from prime.widgets.buttons import BlockButton

def add_hover_effect(widget):

    def colorize(widget, color=(255, 255, 255)):
        widget.color = color

    orig_color = widget.color
    widget.on_hover = lambda: colorize(widget)
    widget.on_nohover = lambda: colorize(widget, orig_color)
    widget.on_mouse_press = lambda: colorize(widget, (60, 60, 60))

window = get_window()

panel = HPanel(20, 20, 10)
window.add(panel)
print "> panel start:", panel.width, panel.height

vpanel = VPanel(100, 100, 10)
print "> vpanel:", vpanel.width, vpanel.height
panel.add(vpanel)
print "> panel added first panel:", panel.width, panel.height

button1 = BlockButton(0, 0, 60, 60, (255, 0, 0))
add_hover_effect(button1)
vpanel.add(button1)
print "> vpanel button added:", vpanel.width, vpanel.height
print "> panel first update:", panel.width, panel.height

button2 = BlockButton(0, 0, 60, 60, (255, 0, 0))
add_hover_effect(button2)
vpanel.add(button2)
print "> vpanel button2 added:", vpanel.width, vpanel.height
print "> panel second update:", panel.width, panel.height

vpanel2 = VPanel(0, 0, 10)
print "> vpanel2", vpanel2.width, vpanel2.height
panel.add(vpanel2)

button3 = BlockButton(0, 0, 60, 60, (255, 0, 0))
add_hover_effect(button3)
vpanel2.add(button3)
print "> vpanel2", vpanel2.width, vpanel2.height

button4 = BlockButton(0, 0, 60, 60, (255, 0, 0))
add_hover_effect(button4)
vpanel2.add(button4)
print "> vpanel2", vpanel2.width, vpanel2.height

button5 = BlockButton(0, 0, 60, 60, (255, 0, 0))
add_hover_effect(button5)
vpanel2.add(button5)
print "> vpanel2", vpanel2.width, vpanel2.height
print "> panel:", panel.width, panel.height

################################################################################

panel2 = VPanel(300, 20, 10)
window.add(panel2)

hpanel1 = HPanel(0, 0, 10)
panel2.add(hpanel1)

button6 = BlockButton(0, 0, 60, 60, (255, 0, 0))
add_hover_effect(button6)
hpanel1.add(button6)

button7 = BlockButton(0, 0, 60, 60, (255, 0, 0))
add_hover_effect(button7)
hpanel1.add(button7)

print "> panel2", panel2.width, panel2.height

hpanel2 = HPanel(0, 0, 10)

button8 = BlockButton(0, 0, 60, 60, (255, 0, 0))
add_hover_effect(button8)
hpanel2.add(button8)

button9 = BlockButton(0, 0, 60, 60, (255, 0, 0))
add_hover_effect(button9)
hpanel2.add(button9)

button10 = BlockButton(0, 0, 60, 60, (255, 0, 0))
add_hover_effect(button10)
hpanel2.add(button10)

panel2.add(hpanel2)
print "> panel2", panel2.width, panel2.height

hpanel3 = HPanel(0, 0, 10)

button11 = BlockButton(0, 0, 60, 60, (255, 0, 0))
add_hover_effect(button11)
hpanel3.add(button11)

panel2.add(hpanel3)
print "> panel2", panel2.width, panel2.height

pyglet.app.run()
