import pyglet

from prime.graphics.base import Graphic

class Widget(Graphic, pyglet.event.EventDispatcher):
    """Superclass for all widgets.  pyglet event able class."""

    def __init__(self, x=0, y=0, width=0, height=0):
        Graphic.__init__(self, x, y, width, height)

    def hits(self, x=0, y=0):
        """Test if in this point widget is in focus of an event."""
        return False

    def click(self):
        self.dispatch_event("on_click")

    def mouse_press(self):
        self.dispatch_event("on_mouse_press")
    
    def mouse_release(self):
        self.dispatch_event("on_mouse_release")

    def mouse_motion(self):
        self.dispatch_event("on_mouse_motion")

    def mouse_enter(self):
        self.dispatch_event("on_mouse_enter")

    def mouse_leave(self):
        self.dispatch_event("on_mouse_leave")

    def hover(self):
        self.dispatch_event("on_hover")

    def nohover(self):
        self.dispatch_event("on_nohover")

Widget.register_event_type("on_click")
Widget.register_event_type("on_hover")
Widget.register_event_type("on_nohover")
Widget.register_event_type("on_mouse_press")
Widget.register_event_type("on_mouse_release")
Widget.register_event_type("on_mouse_motion")
Widget.register_event_type("on_mouse_enter")
Widget.register_event_type("on_mouse_leave")
